'* ---------------------------------------------------------------------------
'* Program shell generated by utility 'glade2bas'
'* provided by Klaus Siebke, http://www.siebke.com
'* Dieser Programmrahmen wurde generiert durch das Werkzeug 'glade2bas'
'*
'* Generated at / Generierung am 25/01/2011 16:34
'* ---------------------------------------------------------------------------

'******************************************************************************
'* Program name: lunar
'*
'* Version:      1.0
'*
'* Author:       Klaus Siebke, www.siebke.com
'*
'* Description / Beschreibung:
'* --------------------------
'*
'* This program visualizes the lunar phases using FreeBasic, Gtk+/Glade 
'* and Cairo
'* For more details about the lunar phases see: 
'* http://en.wikipedia.org/wiki/Lunar_phase
'* The current moon image is shown here: 
'* http://aa.usno.navy.mil/idltemp/current_moon.php
'*
'* More Cairo examples can be found here: http://cairographics.org/examples/ 
'* 
'* --- 
'* 
'* Dieses Programm stellt die Mondphasen unter Verwendung von FreeBasic,
'* Gtk+/Glade und Cairo dar
'* Fuer weitere Informationen siehe:
'* http://de.wikipedia.org/wiki/Mondphasen
'* Das aktuelle Mondbild finden Sie hier:
'* http://aa.usno.navy.mil/idltemp/current_moon.php
'*
'* Weitere Cairo-Beispiele finden Sie hier: http://cairographics.org/examples/
'*
'*
'* License / Lizenz:
'* ----------------
'*
'* (English Version)
'*
'* C. 2011 by Klaus Siebke, www.siebke.com
'*
'* Permission to use, copy, modify, distribute and sell this software
'* and its documentation for any purpose is hereby granted without fee,
'* provided that the above copyright notice appear in all copies and
'* that both that copyright notice and this permission notice appear
'* in supporting documentation.
'* It is provided "as is" without express or implied warranty.
'*
'* The moon icon is under public domain license - see:
'* http://www.rw-designer.com/icon-download.php?id=346
'*
'* (Deutsche Version)
'*
'* C. 2011 bei Klaus Siebke, www.siebke.com
'*
'* Sie erhalten die Erlaubnis, dieses Programm und die zugehoerige Dokumentation
'* fuer beliebige Zwecke kostenlos zu benutzen, zu kopieren, zu veraendern, 
'* weiterzugeben oder zu verkaufen, unter der Voraussetzung, dass Sie diese
'* Lizenzbestimmung und diesen Text auch in Ihre daraus erstellten Programme bzw.
'* Dokumentationen uebernehmen.
'* Dieses Werk wird Ihnen so ueberlassen "wie es ist", auf eigene Gefahr und ohne 
'* jegliche Gewaehrleistung.
'*
'* Das Mond-Symbol (Ikone) steht unter der Lizenz zur gemeinschaftlichen Nutzung
'* (=Public Domain) - siehe: http://www.rw-designer.com/icon-download.php?id=346 
'*
'******************************************************************************
'*
'*  H I N T  F O R  W I N D O W S /  H I N W E I S  F U E R  W I N D O W S
'*
'*  If the final application shall only show the GUI and not the command window,
'*  compile the application with "fbc -s gui lunar.bas". If you want to add
'*  an icon to the executable as well, than use the following compile command:
'*  "fbc -s gui lunar.bas lunar.rc".
'*  Applies to Windows operating systems only - not necessary for Linux.
'*
'*
'*  Wenn die fertige Anwendung nur im GUI-Modus laufen soll (ohne zusaetzliches
'*  cmd-Fenster), einfach mit "fbc -s gui <programm>.bas" umwandeln. Wenn Sie 
'*  der ausfuehrbaren Datei noch ein Symbol (Ikone) hinzufuegen moechten, geben
'*  zum Umwandeln: "fbc -s gui lunar.bas lunar.rc" ein. Dies betrifft nur 
'*  Windows-Systeme - unter Linux nicht erforderlich.
'*
'******************************************************************************

'******************************************************************************
'* Include to be compatible with some VB commands / Ermoeglichen VB Befehle
'******************************************************************************
#include "vbcompat.bi"

'******************************************************************************
'* Includes for Gtk / Definitionen fuer Gtk
'******************************************************************************
#include "gtk/gtk.bi"
#include "gtk/libglade/glade-xml.bi"
'******************************************************************************
'* Includes for Cairo / Definitionen fuer Cairo
'******************************************************************************
#include once "cairo/cairo.bi"

'******************************************************************************
'* Include for Internationalization / Definitionen fuer Mehrsprachigkeit
'******************************************************************************
#include "multilingual.bi"

#define NULL 0 
'******************************************************************************
'* Subroutines (callbacks) or 'events' in Visual Basic notation
'* Definition der Unterprogramme bzw. 'events' in Visual Basic notation
'******************************************************************************
'1) corresponding to the signals in the glade xml file / analog zu den Signalen
'   in der glade xml Datei
#include "lunar.decl"

'2) own routines / Eigene Routinen
''declare sub xxx()
declare sub DrawMoonPhase()
declare sub DrawCoordinateSystem()

'******************************************************************************
'* Data definitions / Datendefinitionen
'******************************************************************************
dim shared xml            as GladeXML ptr
dim shared slash          as string
dim shared winLunar       as GtkWidget ptr
dim shared lblMessage     as GtkWidget ptr 
dim shared entMoonPerCent as GtkWidget ptr 
dim shared drawMoon       as GtkImage ptr 

dim shared cairo_surface  as cairo_surface_t ptr  
dim shared cr             as cairo_t ptr  
     
dim shared Hemisphere     as string 
dim shared Halftime       as string 
dim shared visiblpercent  as integer

const programname = "lunar"

'******************************************************************************
'*
'*  =========================
'*  START OF THE MAIN PROGRAM
'*  BEGINN DES HAUPTPROGRAMMS
'*  =========================
'*
'******************************************************************************

'******************************************************************************
'*  Choose correct slash for the OS / Betriebssystemabhaengiger Pfadbezeichner
'******************************************************************************
    slash = "/"
    #ifdef __FB_WIN32__
       slash = "\"
    #endif

'******************************************************************************
' INTERNATIONALIZATION / INTERNATIONALISIERUNG
'******************************************************************************
'   initialize text domain / Textdomaene initialisieren
    fbsetlocale("")
    settextdomain (programname,  exepath+"/share/locale")
'   very important: set code set to unicode
'   sehr wichtig: Zeichensatz auf Unicode stellen
    fbbindtextdomaincodeset (programname, "UTF-8")

'******************************************************************************
'*  Initialize Gtk / GUI (Gtk) initialisieren
'******************************************************************************
' Initialise GTK
 
    IF gtk_init_check (NULL, NULL) = False THEN    
       print *__("GTK+ could not be initialized. Please check your installation!")
       end 8       
    endif

'******************************************************************************
'*  Specify the windows to be shown / Anzuzeigende Fenster spezifizieren
'******************************************************************************
    if fileexists(exepath + slash + "lunar.glade") then
       xml = glade_xml_new( exepath + slash + "lunar.glade", NULL, NULL ) 
    else
       print *__("Glade ressource file 'lunar.glade' not found. Please check your installation!")
       end 8
    end if

'******************************************************************************
'*  Reference some widgets / Fenster+Felder referenzieren
'******************************************************************************
    winLunar = glade_xml_get_widget( xml, "winLunar" ) 
    lblMessage = glade_xml_get_widget( xml, "lblMessage" ) 
    drawMoon = gtk_image(glade_xml_get_widget(  xml, "drawMoon")	)
    entMoonPerCent =  glade_xml_get_widget( xml, "entMoonPerCent" )    

'******************************************************************************
'*  Initial settings / Voreinstellungen
'******************************************************************************
    gtk_combo_box_set_active ( Gtk_Combo_Box (glade_xml_get_widget( xml, "cmbHemisphere" )), 0)
    gtk_combo_box_set_active ( Gtk_Combo_Box (glade_xml_get_widget( xml, "cmbHalftime" )), 0)    


'******************************************************************************
'*  Display main window(s) / Hauptfenster anzeigen
'******************************************************************************

    gtk_widget_show_all( winLunar)

    glade_xml_signal_autoconnect( xml )

'******************************************************************************
'*  The main GUI loop starts / Hier beginnt die eigentliche GUI-Verarbeitung
'*  ------------------------------------------------------------------------
'*
'*  I M P O R T A N T  / W I C H T I G :
'*
'*  gtk_main can only be terminated by function gtk_main_quit(), so remember to
'*  define a signal to quit the application and call gtk_main_quit() in the
'*  associated SUB - e.g. by signal on_xxx_delete_event (xxx = window name)
'*
'*  gtk_main kann nur durch die Funktion gtk_main_quit() beendet werden, daher
'*  nicht vergessen, ein Signal zum Beenden der Anwendung zu definieren und 
'*  in der zugehoerigen SUB die Funktion gtk_main_quit() aufzurufen - z.B. 
'*  durch das Signal on_xxx_delete_event (xxx = Name des Fensters)
'*
'******************************************************************************
    gtk_main( ) 

'******************************************************************************
'*  Wrap up / Abschliessende Schritte
'******************************************************************************
'   a) unattach xml reference / xml Referenz abbauen
    g_object_unref( xml )

'   b) Finish program with return code 0 / Programm mit Returncode 0 beenden
    end 0


'******************************************************************************
'*
'*  =======================
'*  END OF THE MAIN PROGRAM
'*  ENDE DES HAUPTPROGRAMMS
'*  =======================
'*
'******************************************************************************

'------------------------------------------------------------------------------
'  now the SUB programs start ... / ab hier Unterprogramme (SUB's) ...
'------------------------------------------------------------------------------

sub on_winLunar_delete_event cdecl alias "on_winLunar_delete_event" (byval object as GtkObject ptr, byval user_data as gpointer) export
'******************************************************************************
'* put your code below for signal on_winLunar_delete_event
'******************************************************************************
   gtk_main_quit()
end sub

sub on_btnDrawMoon_clicked cdecl alias "on_btnDrawMoon_clicked" (byval object as GtkObject ptr, byval user_data as gpointer) export
'******************************************************************************
'* put your code below for signal on_btnDrawMoon_clicked
'******************************************************************************
   dim msgtext as string

'  get the entered percentage / Eingegebenen Prozentsatz lesen   
   visiblpercent = val (*gtk_entry_get_text (GTK_ENTRY (entMoonPerCent)))
   
'  clear the message / Loeschen des Meldungsfelds  
   gtk_label_set_text (GTK_LABEL (glade_xml_get_widget( xml, "lblMessage" )), "")

   if visiblpercent > 100 then
      msgtext =  *__("Invalid percentage entered")
      gtk_label_set_text (GTK_LABEL (glade_xml_get_widget( xml, "lblMessage" )), msgtext)
      exit sub
   end if
   
'  Get Hemisphere / Ermitteln Hemisphaere   
   Hemisphere = *gtk_combo_box_get_active_text ( Gtk_Combo_Box (glade_xml_get_widget( xml, "cmbHemisphere" )))
'  Get half time (growing/shrinking) / Ermitteln Halbzeit (zunehmend/abnehmend)   
   Halftime   = mid(*gtk_combo_box_get_active_text ( Gtk_Combo_Box (glade_xml_get_widget( xml, "cmbHalftime" ))),1,1)

'  Lets draw it / Zeichnung erstellen   
   DrawMoonPhase() 


  
end sub

sub DrawMoonPhase()
'******************************************************************************
'* Draw the moon image / Zeichnen der Mondform
'******************************************************************************

   const SCR_W = 640
   const SCR_H = 480
   const PI = 3.14159265358979323846#
   dim visible as double 
   dim drawarea as gdkpixbuf ptr
   
'  Create a pixbuf / Erstellen pixbuf
   drawarea = gdk_pixbuf_new( GDK_COLORSPACE_RGB, TRUE, 8, SCR_W, SCR_H )

   visible = visiblpercent / 100

'  Create cairo surface / Erstellen einer cairo-Oberflaeche
   cairo_surface =  cairo_image_surface_create_for_data(gdk_pixbuf_get_pixels(drawarea), _
											CAIRO_FORMAT_ARGB32, SCR_W, _
											SCR_H, gdk_pixbuf_get_rowstride(drawarea))	

'   Create cairo renderering / Erstellen einer cairo-Darstellung
	cr = cairo_create(cairo_surface)
	   

'   Optional:   
'	cairo_scale(cr, .5, .5) 'shrinks all by 50% / verkleinert alles auf 50%
'	cairo_scale(cr, 1.5, 1.5) 'enlarges all by 50% / vergroessert alles um 50%

'   -----------------------------------------------------
'   Set the background color / Hintergrundfarbe festlegen
'   -----------------------------------------------------
'   draw the entire context white / Hintergrund weiss
'	cairo_set_source_rgba(cr, 1, 1, 1, 1)

'   Convert from RGB into Cairo by e.g red: (255-<red-component>)/255 (not working perfectly!)
'   examples:
	cairo_set_source_rgba(cr, (255.0-98.0)/255.0, (255.0-145.0)/255.0, (255.0-196.0)/255.0, 1)
'	cairo_set_source_rgba(cr, (255-120)/255, (255-150)/255, (255-220)/255, 1)
'	cairo_set_source_rgba(cr, (255-14)/255, (255-28)/255, (255-63)/255, 1)	
'	cairo_set_source_rgba(cr, 0.2, 0.23, 0.9, 1)
'	cairo_set_source_rgb(cr, 0.2, 0.23, 0.9)	'kind of red
'	cairo_set_source_rgb(cr, 0.9, 0.1, 0.1)     'kind of blue
'	cairo_set_source_rgb(cr, 0.4, 0.9, 0.4)     'kind of green
	cairo_paint(cr)


'	center coordinate system in the middle of the screen
'	Koordinatensystem in der Bildschirmmitte zentrieren
	cairo_translate(cr, SCR_W/2, SCR_H/2)  




'   line thickness set to 1 / Linienstaerke auf 1 setzen
    cairo_set_line_width(cr, 1)
'   Outline black / Aussenlinie schwarz
    cairo_set_source_rgb(cr, 0, 0, 0)
	
'   Full circle filled white / Vollkreis weiss gefuellt
    cairo_arc(cr, 0, 0, 100, 0, 2*PI)
    cairo_stroke_preserve(cr)
    cairo_set_source_rgb(cr, 1, 1, 1)
    cairo_fill(cr)


	if visible < 1 then
	   if visible < .5 then
	      if Hemisphere = "N" and Halftime = "1" or Hemisphere = "S" and Halftime = "2" then
	'        Semi circle black on the left / Halbkreissegment schwarz links
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_arc(cr, 0, 0, 100, PI/2, PI*3/2)
	         cairo_close_path(cr)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_fill(cr)
	'        Draw an ellipses horizontal scaled by visible / Eine horizontal skalierte Ellipse zeichen gem. visible
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_scale(cr, 1 - visible*2 , 1)
	         cairo_set_line_width(cr, 1)    
	         cairo_arc(cr, 0, 0, 100, 0, 2*PI)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_fill(cr)
	      else 
	'        Semi circle black on the right / Halbkreissegment schwarz rechts
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_arc(cr, 0, 0, 100, PI*3/2, PI/2)
	         cairo_close_path(cr)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_fill(cr)
	'        Draw an ellipses horizontal scaled by visible / Eine horizontal skalierte Ellipse zeichen gem. visible
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_scale(cr, 1 - visible*2 , 1)
	         cairo_set_line_width(cr, 1)    
	         cairo_arc(cr, 0, 0, 100, 0, 2*PI)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_fill(cr)	      
	      end if
	   else  
          if Hemisphere = "N" and Halftime = "1" or Hemisphere = "S" and Halftime = "2" then
	'        Outline black / Aussenlinie schwarz
	         cairo_set_source_rgb(cr, 0, 0, 0)   
	'        Full circle filled black / Vollkreis schwarz
	         cairo_arc(cr, 0, 0, 100, 0, 2*PI)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_fill(cr)
	'        Semi circle white on the right / Halbkreissegment weiss rechts
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_arc(cr, 0, 0, 100, PI*3/2, PI/2)
	         cairo_close_path(cr)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 1, 1, 1)
	         cairo_fill(cr)
	'        Draw an ellipses horizontal scaled by visible / Eine horizontal skalierte Ellipse zeichen gem. visible
	         cairo_set_source_rgba  (cr, 1, 1, 1, 0)    
	         cairo_scale(cr, (1 - visible*2) , 1)  
	         cairo_arc(cr, 0, 0, 100, 0, 2*PI)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 1, 1, 1)
	         cairo_fill(cr)
	         cairo_stroke(cr)
	      else 
	'        Outline black / Aussenlinie schwarz
	         cairo_set_source_rgb(cr, 0, 0, 0)   
	'        Full circle filled black / Vollkreis schwarz
	         cairo_arc(cr, 0, 0, 100, 0, 2*PI)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_fill(cr)
	'        Semi circle white on the left / Halbkreissegment weiss links
	         cairo_set_source_rgb(cr, 0, 0, 0)
	         cairo_arc(cr, 0, 0, 100, PI/2, PI*3/2)
	         cairo_close_path(cr)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 1, 1, 1)
	         cairo_fill(cr)
	'        Draw an ellipses horizontal scaled by visible / Eine horizontal skalierte Ellipse zeichen gem. visible
	         cairo_set_source_rgba  (cr, 1, 1, 1, 0)    
	         cairo_scale(cr, (1 - visible*2) , 1)  
	         cairo_arc(cr, 0, 0, 100, 0, 2*PI)
	         cairo_stroke_preserve(cr)
	         cairo_set_source_rgb(cr, 1, 1, 1)
	         cairo_fill(cr)
	         cairo_stroke(cr)	
	      end if
	   end if
	
	 
	end if

'   restore scale (for extra drawings) 
'   Urspruengliche Skalierung wieder herstellen (fuer weitere Zeichnungen)
    cairo_scale(cr, 1 / (1 - visible*2) , 1)

'   Draw coordinate system, if requested
'   Koordinatensystem ausgeben, falls gewuenscht
    if gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(glade_xml_get_widget(xml, "chkCoordinates"))) = 1 then
       DrawCoordinateSystem()
    end if

	   
	cairo_destroy(cr) 

'   Fill GtkImage with cairo drawing / Cairo-Zeichnung in GtkImage einfuegen
	gtk_image_set_from_pixbuf (drawMoon, drawarea)
	
end sub
	
sub DrawCoordinateSystem()
'******************************************************************************
'* Draw coordinate system / Koordinatensystem ausgeben
'******************************************************************************
	dim i as integer

'   line thickness 1	
'   Linienbreite 1 dick
    cairo_set_line_width(cr, 1)

'   set line color 
'   Linienfarbe 
'   cairo_set_source_rgb(cr, 0, 0, 0)  'black
	cairo_set_source_rgb(cr, 0.2, 0.23, 0.9)  'kind of red    

'   draw y-axis
'   Y-Achse zeichnen
	cairo_move_to (cr, 0, -200)
	cairo_line_to (cr, 0, 200)
	cairo_stroke(cr)

'   draw x-axis
'   X-Achse zeichnen
	cairo_move_to (cr, -200, 0)
	cairo_line_to (cr, 200, 0)
	cairo_stroke(cr)
	
'   scale the y-axis
'   Y-Achse skalieren
	for i = -200 to 200 step 10
	cairo_move_to (cr, -5, i)
	cairo_line_to (cr, 5, i)
	cairo_stroke(cr)
	next i

'   scale the x-axis
'   X-Achse skalieren
	for i = -200 to 200 step 10
	cairo_move_to (cr, i, -5)
	cairo_line_to (cr, i, 5)
	cairo_stroke(cr)
	next i


end sub
	

