'* multilingual.bi
'* ---------------------------------------------------------------------
'* Include for internationalization of FreeBASIC programs
'* Baustein für die Internationalisierung von FreeBASIC Programmen
'* ---------------------------------------------------------------------
'* 
'* C. 2010 Klaus Siebke, www.siebke.com
'*
'* This program is free software; you can redistribute it and/or
'* modify it under the terms of version 3 of the GNU General Public
'* License as published by the Free Software Foundation.
'*
'* This program is distributed in the hope that it will be useful,
'* but WITHOUT ANY WARRANTY; without even the implied warranty of
'* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'* GNU General Public License for more details.
'*
'* You should have received a copy of the GNU General Public License
'* along with this program; if not, write to the Free Software
'* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
'* MA 02110-1301, USA.
'* ---------------------------------------------------------------------
#ifdef __FB_WIN32__
Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" (ByVal As Integer, ByVal As Integer, ByVal As String, ByVal As Integer) As Integer
#define LC_ALL 0
#define LC_COLLATE 1
#define LC_CTYPE 2
#define LC_MONETARY 3
#define LC_NUMERIC 4
#define LC_TIME 5
#define LC_MIN LC_ALL
#define LC_MAX LC_TIME
#Inclib "iconv"
#Inclib "intl"
extern "c"
declare function setlocale ( byval as integer, byval as const zstring ptr ) as zstring ptr
'DECLARE FUNCTION setlocale CDECL ALIAS "setlocale" ( byval as integer, byval as const zstring ptr ) as zstring ptr
declare function textdomain ( byval as const zstring ptr ) as zstring ptr
'DECLARE FUNCTION textdomain CDECL ALIAS "textdomain" ( byval as const zstring ptr ) as zstring ptr
declare function gettext ( byval as const zstring ptr ) as zstring ptr
'DECLARE FUNCTION gettext CDECL ALIAS "gettext" ( byval as const zstring ptr ) as zstring ptr
declare function bindtextdomain ( byval as const zstring ptr, byval as const zstring ptr ) as zstring Ptr
'DECLARE FUNCTION bindtextdomain CDECL ALIAS "bindtextdomain" ( byval as const zstring ptr, byval as const zstring ptr ) as zstring Ptr
' Specify the character encoding in which the messages from the
'   DOMAINNAME message catalog will be returned.
declare function bind_textdomain_codeset ( byval as const zstring ptr, byval as const zstring ptr) as zstring ptr

end extern


SUB fbsetlocale (lcall As string)
  setlocale(LC_ALL, lcall)
end sub

SUB settextdomain (domname As string, dompath as string)
'  setlocale(LC_ALL, "")
  bindtextdomain(domname, dompath)
  textdomain(domname)
end sub


FUNCTION fbgettext (tobetranslated As string) as zstring ptr
'  print "tobetranslated= "; tobetranslated
  fbgettext = gettext(tobetranslated)
end function


FUNCTION fbtextdomain (domname As string) as zstring ptr
  fbtextdomain = textdomain(domname)
end function



FUNCTION fbbindtextdomain (domname As string, dompath As string) as zstring ptr
  fbbindtextdomain = bindtextdomain(domname, dompath)
end function

FUNCTION fbbindtextdomaincodeset (domname As string, codeset As string) as zstring ptr
  fbbindtextdomaincodeset = bind_textdomain_codeset(domname, codeset)
  
end function

#endif  

#ifdef __FB_LINUX__
#Inclib "multilingual"
extern "c"
' these SUB's/FUNCTION's are part of the c library multilingual.c
' diese SUB/FUNCTION befindet sich in der  c-Bibliothek multilingual.c
DECLARE SUB fbsetlocale CDECL ALIAS "fbsetlocale" (ByVal lcall As string)
DECLARE SUB settextdomain CDECL ALIAS "settextdomain" (ByVal domname As string, ByVal dompath as string)
DECLARE FUNCTION fbgettext CDECL ALIAS "fbgettext" (ByVal tobetranslated As string) as zstring ptr
DECLARE FUNCTION fbtextdomain CDECL ALIAS "fbtextdomain" (ByVal domname As string) as zstring ptr
DECLARE FUNCTION fbbindtextdomain CDECL ALIAS "fbbindtextdomain" (ByVal domname As string, ByVal dompath as string) as zstring ptr
DECLARE FUNCTION fbbindtextdomaincodeset CDECL ALIAS "fbbindtextdomaincodeset" (ByVal domname As string, ByVal codeset as string) as zstring ptr
end extern
#endif 


Function get_locale () As String
get_locale = ""

#If Defined(__FB_WIN32__)

Dim sBuffer As String * 32, nResult As Integer

nResult = GetLocaleInfo(&h800, &h59, sBuffer, 32)

If nResult > 0 Then
    get_locale  =  Left(sBuffer, nResult - 1)
End If

#ElseIf Defined(__FB_LINUX__)


Dim ff As Integer = FreeFile
Open Pipe "locale" For Input As ff

Dim sRetVal As String
dim locstring as string

Do Until EOF(ff)
    Line Input #ff, sRetVal
    If LCase(Left(sRetVal, 5)) = "lang=" Then
        locstring = LCase(Mid(sRetVal, 6))
'        print "get_locale=", get_locale
        If InStr(locstring, "_") Then ' Schema: de_DE
'                print "locstring=", locstring
            get_locale = Left(locstring, InStr(locstring, "_") - 1)
        EndIf
        Exit Do
    EndIf
Loop

Close #ff

#EndIf

End Function

' Define a short form of fbgettext for easy of use
#Define __( String ) fbgettext( String )

